<?php // Event Helper Functions // 

class EventHelper {
	
	// Get Template File //
	function get_plugin_template($filename, $subname = null) {
		if (file_exists(dirname(__FILE__) . "/templates/" . $filename . ($subname != null ? '-'.$subname : null) . ".php"))
			include_once(dirname(__FILE__) . "/templates/" . $filename . ($subname != null ? '-'.$subname : null) . ".php");
	}
	
	function get_event_date_meta($post_id) {
		global $wpdb, $post, $timezone_diff;
		$data = array();
		
		$wpdb->query("SELECT meta_key, meta_value
					  FROM p2p_postmeta
					  WHERE post_id = '".$post_id."'
					  AND meta_key LIKE '_event_date_date%'
					  ORDER BY meta_id");
		
		foreach($wpdb->last_result as $k => $v) {
			$num = substr($v->meta_key, strrpos($v->meta_key, '_')+1, strlen($v->meta_key));
			$data[$num]['date'] = strtotime(date('F j, Y', $v->meta_value+$timezone_diff));
			$data[$num]['start'] = get_post_meta($post_id, '_event_date_starttime_'.$num, true);
			$data[$num]['end'] = get_post_meta($post_id, '_event_date_endtime_'.$num, true);
		};	
		return $data;
	}
	
	function get_event_by_date($after = false) {
		global $wpdb, $timezone_diff;
			
		if ($after == true) $compare = "AND p2p_postmeta.meta_value > '".(strtotime(date('F j, Y')) + $timezone_diff)."'";
		else $compare = "AND p2p_postmeta.meta_value >= '".(strtotime(date('F j, Y'))-$timezone_diff)."' AND p2p_postmeta.meta_value <= '".(strtotime(date('F j, Y')) + $timezone_diff)."'";
					
		$data = $wpdb->get_results("SELECT $wpdb->posts.*, $wpdb->postmeta.*
									FROM $wpdb->posts, $wpdb->postmeta
									WHERE $wpdb->postmeta.post_id = $wpdb->posts.ID AND 
									$wpdb->posts.post_status = 'publish' AND
									$wpdb->postmeta.meta_key LIKE '_event_date_date%'
									$compare
									GROUP BY $wpdb->posts.ID
									ORDER BY $wpdb->postmeta.meta_value ,$wpdb->posts.ID ASC
									LIMIT 0,3", OBJECT);
		
		return $data;
	}
	
	function the_date_icon($dates, $echo = true) {
		$i = 0;
		foreach ($dates as $date) {
			if ((count($dates) > 3 && $date['date'] >= strtotime(date('F j, Y'))+$timezone_diff) || count($dates) <= 3) {
				if ($i++ != 0) {
					$output .= '<hr/>';
				}
				$output .= date('M', $date['date']) . '<span>' . date('d', $date['date']) . '</span>';
				if ($i == 3) {
					break;
				}
			}
		}

		if ($echo == true) { return $output; }
		else { echo $output; } 
	}
	
	function date_range_check($dates, $startdate, $enddate) {
		
		// Date Range //	 
		if (count($dates) == 2 && $dates[0]['end'] == null && $dates[1]['start'] == null) {
			
			// If Start Date Within Display Range //
			if (strtotime(date('F j, Y', $dates[0]['date'])) >= strtotime($startdate) && strtotime(date('F j, Y', $dates[0]['date'])) <= strtotime($enddate))
				return true;			
			// If End Date Within Display Range //
			else if (strtotime(date('F j, Y', $dates[1]['date'])) >= strtotime($startdate) && strtotime(date('F j, Y', $dates[1]['date'])) <= strtotime($enddate))
				return true;
			// If Display Range within Date Range
			else if (strtotime($startdate) >= strtotime(date('F j, Y', $dates[0]['date'])) && strtotime($enddate) <= strtotime(date('F j, Y', $dates[1]['date'])))
				return true;
			// Not in Range //
			else
				return false;

		// Single or Multiple Dates //
		} else if (count($dates) > 0) {
			foreach ($dates as $date) {
				// If Date within Range //
				if (strtotime($startdate) <= strtotime(date('F j, Y', $date['date'])) && strtotime($enddate) >= strtotime(date('F j, Y', $date['date'])))
					return true;
			}
			return false;
		} else 
			return false;
	}
	
	function date_display($dates, $return = false) {
		$text = "";
		if (count($dates) == 2 && $dates[0]['end'] == null && $dates[1]['start'] == null) {
			$text .= utf8_encode(strftime('%B %e, %Y', $dates[0]['date']));
			if ($dates[0]['start'] != null) 
				$text .= ' at '.$dates[0]['start'];
			$text .= ' until<br/>'.utf8_encode(strftime('%B %e, %Y', $dates[1]['date']));
			if ($dates[1]['end'] != null)
				$text .= ' at '.$dates[1]['end'];
		} else if (count($dates) == 1) {
			$text .= utf8_encode(strftime('%B %e, %Y', $dates[0]['date']));
			if ($dates[0]['start'] != null)
				$text .= ' at '.$dates[0]['start'];
			if ($dates[0]['end'] != null)
				$text .= ' until '.$dates[0]['end'];
		} else if (count($dates) != 0) { 
			foreach ($dates as $date) {
				$text .= utf8_encode(strftime('%B %e, %Y', $date['date']));
				if ($date['start'] != null)
					$text .= ' at '.$date['start'];
				if ($date['end'] != null)
					$text .= ' until '.$date['end'];
				$text .= '<br/>';
			}	
		}
		if ($return == true) 
			return $text;
		else 
			echo $text;
	}
	
		// Replacement Excerpt Function //
	function display_excerpt() {
		if (($content = get_the_excerpt()) != null) {
			echo $content;
		} else {
			echo content_limit(800);
		}
	}

	// Get Tweet for Hashtag //
	function get_tweet($hashtag) {
	    $feed = "http://search.twitter.com/search.atom?q=+".$hashtag."&rpp=1";
	
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_URL, $feed);
	    $feed = curl_exec($ch);
	    curl_close($ch);
	
		$tweet = new SimpleXMLElement($feed);
		
		if (!isset($tweet->entry)) 
			return false;
		else {
			$member = $tweet->entry->link[1]->attributes();
			$twitter['image'] = $member['href'];
			$twitter['author'] = '<a href="'.$tweet->entry->author->uri.'" target="_blank">'.$tweet->entry->author->name.'</a>';
			$twitter['date'] = strtotime($tweet->entry->published);
			$twitter['tweet'] = html_entity_decode($tweet->entry->content);
			return $twitter;
		}
	}
	
	// Determine Post Feature Image //
	function get_the_article_image($size = 'full', $noparse = false) {
		global $post;
				
		if (has_post_thumbnail($post->ID)) {
			if ($size == 'large') {
				$thumb_id = get_post_thumbnail_id($post->ID);
				$largeImage = wp_get_attachment_image_src($thumb_id, $size);
				if ($largeImage[1] == 600)
					return get_the_post_thumbnail($post->ID, $size);
				else
					return get_the_post_thumbnail($post->ID, 'twocol');
			}
			return get_the_post_thumbnail($post->ID, $size);		 
		} else if ($noparse == false) {
			if ($youtube = self::has_youtube($size)) 
				return $youtube;
			else if ($vimeo = self::has_vimeo($size))
				return $vimeo;
			else if ($image = self::get_first_image($size))
				return $image;
			else 
				return false;
		} else 
			return false;
	}
	
	// Find First Image in a Post //
	function get_first_image($size) {
		global $post;
		
		ob_start();
		ob_end_clean();
		
		preg_match_all( '|<img.*?src=[\'"](.*?)[\'"].*?>|i', $post->post_content, $matches );
		$first_img = $matches [1] [0];
			
		if (empty($first_img))
		    $first_img = false;
		else
			return '<img src="'.$first_img.'" '.get_size($size, 'image').' />';
	}
	
	// Display Featured Image //
	function the_article_image($size = 'full', $noparse = false) { 	
		global $post;
		
		if (($image = self::get_the_article_image($size, $noparse)) != false) : ?>
		<figure class="media">
			<?php echo $image; ?>				
			<?php if ($size != 'threecol' && $size != 'twocol') { 
				$thumbnail_id = get_post_thumbnail_id($post->ID);
				if ($thumbnail_id != null) {
					$thumbnail_image = get_posts(array('p' => $thumbnail_id, 
													   'post_type' => 'attachment'));
					if ($thumbnail_image && isset($thumbnail_image[0]) && $thumbnail_image[0]->post_excerpt != null)
						echo '<figcaption align="bottom">' . $thumbnail_image[0]->post_excerpt . '</figcaption>';
				}
			} ?>
		</figure>	
		<?php endif; ?>	
	
	<? 
	}
	
	// Check if Youtube Shortcode Exists in Post //
	function has_youtube($size) {  
		global $post;
	  
	    if (stripos($post->post_content, '[youtube') !== false ) {  
	    	$value = substr($post->post_content, stripos($post->post_content, '[youtube'), stripos($post->post_content, '[/youtube]'));
	    	$youtube = substr($value, stripos($value, 'v=')+2, strlen($value));
	    	if (strpos($youtube, '?')) 
	    		$youtube = substr($youtube, 0, stripos($youtube, '?'));
	    	if (strpos($youtube, '&'))
	    		$youtube = substr($youtube, 0, stripos($youtube, '&'));
	    	    	
	    	if ($size == 'large' || $size == 'twocol')
	    		return '<iframe '.get_size($size, 'video').' src="http://www.youtube.com/embed/'.$youtube.'?D=1&rel=0&showinfo=0&controls=0&wmode=opaque" frameborder="0" rel="nofollow" allowfullscreen></iframe>';
	    	else 
				return '<img src="http://img.youtube.com/vi/'.$youtube.'/hqdefault.jpg" '.get_size($size, 'image').' />';
	    	
	    } else 
	 		return false;
	}
	
	// Check if Vimeo Shortcode Exists in Post //
	function has_vimeo($size) {  
		global $post;
	  
	    if (stripos($post->post_content, '[vimeo') !== false ) {  
	    	$value = substr($post->post_content, stripos($post->post_content, '[vimeo'), stripos($post->post_content, '[/vimeo]'));
	    	$vimeo = substr($value, strrpos($value, '/')+1, strlen($value));
	    	
	    	if ($size == 'large' || $size == 'twocol')
	    		return '<iframe '.get_size($size, 'video').' src="http://player.vimeo.com/video/'.$vimeo.'?title=0&amp;byline=0&amp;portrait=0" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>';
	    	else if ($size == 'widget') {
	    		$hash = unserialize(file_get_contents("http://vimeo.com/api/v2/video/".$vimeo.".php"));
	    		return '<img src="'.$hash[0]['thumbnail_large'].'" '.get_size($size, 'image').' />';
	    	} else {
		    	$hash = unserialize(file_get_contents("http://vimeo.com/api/v2/video/".$vimeo.".php"));
				return '<img src="'.$hash[0]['thumbnail_medium'].'" '.get_size($size, 'image').' />';
	    	}
	    } else 
	 		return false;
	} 
	
	// Determine Thumbnail Sizes //
	function get_size($size, $type) {
		switch ($size) {
			case 'large': 
				$width = 600; 
				$height = 335; 
				break;
			case 'twocol':
				$width = 270; 
				$height = 167;
				break;
			case 'threecol':
				$width = 158;
				$height = 86;
				break;
			case 'widget':
				$width = 252;
				break;
			case 'thumb':
			case 'thumbnail':
		 	default: 
				$width = 150;
				$height = 100;
		 		break;
		}	
		
		$string = 'width="'.$width.'"';
		if ($type == 'image' && ($size == 'large' || $size == 'twocol')) {
			// do nothing
		} else if (isset($height)) 
			$string .= ' height="'.$height.'"';
			
		return $string;
	} 
	
}
?>
