<?php // ICS_Generator Class //
$ICS_GeneratorCode = new ICS_Generator();
register_activation_hook( __file__, array($ICS_GeneratorCode, 'activate') );

add_filter('rewrite_rules_array', array($ICS_GeneratorCode, 'create_rewrite_rules'));
add_filter('query_vars',array($ICS_GeneratorCode, 'add_query_vars'));

add_filter('admin_init', array($ICS_GeneratorCode, 'flush_rewrite_rules'));
add_filter('template_include', array($ICS_GeneratorCode, 'template_redirect_intercept'));

class ICS_Generator {
	
	 function activate() {
        global $wp_rewrite;
        $this->flush_rewrite_rules();
    }

    function create_rewrite_rules($rules) {
        global $wp_rewrite;
        $newRule = array('ical/(.+)' => 'index.php?event_slug='.$wp_rewrite->preg_index(1));
        $newRules = $newRule + $rules;
        return $newRules;
    }

    function add_query_vars($qvars) {
        $qvars[] = 'event_slug';
        return $qvars;
    }

    function flush_rewrite_rules() {
        global $wp_rewrite;
        $wp_rewrite->flush_rules();
    }
       
    function template_redirect_intercept($template) {
        global $wp_query;
        if ($wp_query->get('event_slug')) {
            $template = WP_PLUGIN_DIR . '/oak-events/templates/content-ics.php';
        }
    	return $template;
    }

    function pushoutput($message) {
        $this->output($message);
    }

    function output( $output ) {
        header( 'Cache-Control: no-cache, must-revalidate' );
        header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
        echo json_encode( $output );
    }
}
