function triggerDate() {
		
	var startDate = jQuery('div#calendars_fields input[id=calendars_startfield]').attr('value');
	if (startDate == 'Start Date' || startDate == 'Date de début') 
		startDate = '';

	var endDate = jQuery('div#calendars_fields input[id=calendars_endfield]').attr('value');
	if (endDate == 'End Date' || endDate == 'Date de fin') 
		endDate = '';

	var keyword = jQuery('#keywords input[type=text]').attr('value');
	if (keyword == 'Search Events' || keyword == 'Rechercher par événements')
		keyword = '';
	
	var category = jQuery('select[name=eventtype]').attr('value');
	if (category == '*')
		category = '';
	
	jQuery('div#loadingicon').show();
	jQuery('input#keyword').val('').blur();

	return	jQuery.ajax({
		url: '/wp-content/plugins/oak-events/templates/content-events.php',
		type: "POST",  			  
		data: "keyword="+keyword+"&startdate="+startDate+"&enddate="+endDate+"&cat="+category,
		success: function(data) {
			jQuery('.eventlisting').html(data);
			jQuery('div#loadingicon').hide();
		}
	}); 
}

jQuery(document).ready(function($) {

	$('input[type=text]').each(function() {
		var title = $(this).attr('placeholder');
		if ($(this).val() == '') {
			$(this).css('color', '#999999').val(title);
		} else if ($(this).val() == title) {
			$(this).css('color', '#999999').val(title);			
		}
		$(this).live('click', function() {
			if ($(this).val() == title) {
				$(this).css('color', '#000000').val(null);
			}
		});
	});

	$('input#calendars_startfield').live('change', function() {
		triggerDate();
	});

	$('input#calendars_endfield').live('change', function() {
		triggerDate();
	});

	$("#startdate").datepicker({
		showOn: "focus",
		dateFormat: 'dd-MM-yy',
	    minDate: 0,
	    onSelect: function(selectedDate) {
	        var instance = $(this).data("datepicker");
	        var date = $.datepicker.parseDate(instance.settings.dateFormat || $.datepicker._defaults.dateFormat, selectedDate, instance.settings);
	        $("#enddate").datepicker("option", "minDate", date);
	        return false;
	    }
	});
	
	$("#enddate").datepicker({
		dateFormat: 'dd-MM-yy',
	    minDate: $('#startdate').val(),
		showOn: "focus"
	});

	$('#keywords').live("submit", function(e) {
		e.preventDefault();
		triggerDate();
	});

	$('select[name=eventtype]').live('change', function() {
		triggerDate();
	});

});
