<?php /*
Plugin Name: OAK Events Calendar
Plugin URI: http://www.oakcomputing.com
Description: Creates an events calendar
Author: OAK Computing
Version: 1.0
Author URI: http://www.oakcomputing.com/
*/

date_default_timezone_set('America/Toronto');
$timezone_diff = 18000; // UTC-5 = 60 second * 60 minutes * 5 hours = 18000

// Initialize Custom Post Type and Meta //
include_once(dirname(__FILE__) . '/helpers.php'); 

if (!class_exists('OAK_Post_Types')) 
	include_once($_SERVER['DOCUMENT_ROOT'].'/wp-content/themes/prosperity/framework/library/posttypes/posttypes.php'); 

add_theme_support('post-thumbnails', array('_events', 'post', 'page'));
$prefix = '_';

$events = new OAK_Post_Types(array(
	'name' 	=> 'Event',
	'plurralname'	=> 'Events',
	'slug' => 'events',
	'supported' 	=> array('title', 'editor', 'thumbnail'),
	'menu_position' => 20

));
	
new OAK_Meta_Fields(array(
		'slug'			=> 'event-date-time',
		'name' 			=> 'Event Date & Time', 
		'post_types' 	=> array('_events'),
		'fields' 		=> array( 
			array(
				'slug'			=> 'event_date',
				'name'			=> 'Date',
				'description'	=> '',
				'type'			=> 'datetime',
				'multiple' 		=> true
			)
		))
	);

new OAK_Meta_Fields(array(
		'slug'			=> 'event-options',
		'name' 			=> 'Event Options', 
		'post_types' 	=> array('_events'),
		'fields' 		=> array( 
			array(
				'slug'			=> 'event_location',
				'name'			=> 'Location Name',
				'description'	=> '',
				'type'			=> 'text',
			),
			array(
				'slug'			=> 'event_website',
				'name'			=> 'Website Link',
				'description'	=> '',
				'type'			=>	'text'			
			),
			array(
				'slug'			=> 'event_street_address',
				'name'			=> 'Location Street Address',
				'description'	=> '',
				'type'			=> 'text',
			),
			array(
				'slug'			=> 'event_price',
				'name'			=> 'Price',
				'description'	=> '',
				'type'			=>	'text'			
			),
			array(
				'slug'			=> 'event_hotel_link',
				'name'			=> 'Hotel Link',
				'description'	=> '',
				'type'			=> 'text',
			),	
			array(
				'slug'			=> 'event_contact',
				'name'			=> 'Contact Information',
				'description'	=> '',
				'type'			=>	'text'			
			)
		)
	)
);

add_action('init', 'taxonomy_init'); 

function taxonomy_init() {
	global $events;
	$events -> add_custom_taxonomy('Category', 'Categories', true);
}

// Initialize Widgets //
include_once(dirname(__FILE__) . '/widgets/todaysevents.widget.php'); 
add_action( 'widgets_init', create_function( '', 'register_widget("Todays_Events");' ) );

include_once(dirname(__FILE__) . '/widgets/upcomingevents.widget.php'); 
add_action( 'widgets_init', create_function( '', 'register_widget("Upcoming_Events");' ) );

// Add ICS Generation for Events //
include_once(dirname(__FILE__) . '/icsgenerator.php'); 

//Template fallback
add_action("template_redirect", 'my_theme_redirect');

function my_theme_redirect() {
    global $wp;

    //A Specific Custom Post Type
    if (isset($wp->query_vars['post_type']) && $wp->query_vars['post_type'] == '_events') {
    	if (is_single()) 
        	$templatefilename = 'single-_events.php';
		else    		
        	$templatefilename = 'archive-_events.php';
        	
        if (file_exists(TEMPLATEPATH . '/' . $templatefilename)) 
            $return_template = TEMPLATEPATH . '/' . $templatefilename;
        else 
            $return_template = dirname( __FILE__ ) . '/templates/' . $templatefilename;
     	
        do_theme_redirect($return_template);

    //A Simple Page
    } else if (isset($wp->query_vars['pagename']) && $wp->query_vars['pagename'] == 'suggest-event') {
        $templatefilename = 'page-suggest-event.php';
        if (file_exists(TEMPLATEPATH . '/' . $templatefilename)) {
            $return_template = TEMPLATEPATH . '/' . $templatefilename;
        } else {
            $return_template = dirname( __FILE__ ) . '/templates/' . $templatefilename;
        }
        do_theme_redirect($return_template);
    }
}

function do_theme_redirect($url) {
    include_once($url);
    die();
}

function national_blog_events() {
	global $wpdb, $wp_query;

	$wpdb->set_blog_id(1);
	$wp_query->query_vars['blogid'] = 1;
	$parseurl = parse_url(get_bloginfo('url'));
	$site = explode('.', $parseurl['host']);
	$query->query_vars['_regional'] = $site[0];
}


?>
