<?php 

if (!class_exists('OAK_Meta_Fields')) {

	class OAK_Meta_Fields {
	
		var $cmf;
	
		function __construct($args) {
			$this->cmf = (object)$args;
			add_action('admin_menu', array(&$this, 'init_meta_fields'));
			add_action('admin_menu', array(&$this, 'init_scripts'));
			add_action('save_post', array(&$this, 'save_custom_fields'), 1, 2);
		}
		
		function init_meta_fields() {
			foreach ($this->cmf->post_types as $posttype) :
				add_meta_box($this->cmf->slug, $this->cmf->name, array(&$this, 'display_custom_fields'), $posttype, 'normal', 'high', $this->cmf->fields);
			endforeach;
		}
		
		function init_scripts() {
			global $pagenow;
			if (is_admin() && ($pagenow == 'post.php' || $pagenow == 'edit.php' || $pagenow == 'post-new.php')) {
				wp_enqueue_script('date-picker', get_bloginfo('template_url') . '/framework/library/posttypes/includes/datepicker.min.js', array('jquery'));
				wp_enqueue_script('multi-field', get_bloginfo('template_url') . '/framework/library/posttypes/includes/multiple-fields.js');
				wp_enqueue_script('custommedia', get_bloginfo('template_url') . '/framework/library/posttypes/includes/custommedia.js');
				wp_enqueue_script('french_date', get_bloginfo('template_url') . '/framework/library/posttypes/includes/date-en.js');
				wp_enqueue_style('date_picker', get_bloginfo('template_url') . '/framework/library/posttypes/includes/ui-smoothness/jquery-ui-1.10.2.custom.css');
				wp_enqueue_style('admin_style', get_bloginfo('template_url') . '/framework/library/posttypes/includes/admin-style.css');
				wp_enqueue_script('media-upload');
				wp_enqueue_script('thickbox');
				wp_enqueue_style('thickbox');
			}
		}
		
	   	function display_custom_fields() { 
			global $post; ?>

			<div class="form-wrap">
			<?php wp_nonce_field('my-custom-fields', 'my-custom-fields_wpnonce', false, true);
			if (!current_user_can('edit_posts', $post->ID))
				return false; ?>

			<?php foreach ($this->cmf->fields as $field) : ?>
			<div class="fieldset-wrap">
			<?php switch ($field['type']) :
					
					// Date Picker Field
					case "datetime": 
					
						$fieldvalues = array();
						$i = 0;
						// Get Multiple or Single Values //
						if ($field['multiple'] == true && get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . "_date_".$i, true) != null) {
							while ($fieldvalue = get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . "_date_".$i, true)) {
								$fieldvalues[$i]['date'] = date('F j, Y', $fieldvalue); 
								$fieldvalues[$i]['starttime'] = get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . "_starttime_".$i, true);
								$fieldvalues[$i]['endtime'] = get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . "_endtime_".$i, true);
								$i++;
							}
						} else if (get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . "_date", true) != null) {
							$fieldvalues[0]['date'] = date('M d, Y', get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . "_date", true));
							$fieldvalues[0]['starttime'] = get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . "_starttime", true);
							$fieldvalues[0]['endtime'] = get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . "_endtime", true);
						} else {
							$fieldvalues[0]['date'] = null;
							$fieldvalues[0]['starttime'] = null;						
							$fieldvalues[0]['endtime'] = null;
						}				
						
						$counter = 0;
						foreach ($fieldvalues as $value) : ?>
						
						<fieldset class="datetime<?php echo ($counter == 0) ? ' original' : null; ?>">
						
							Date: <input type="text" class="calendar" name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>_date]<?php if ($field['multiple'] == true) : ?>[]<?php endif; ?>" id="<?php echo OAK_PREFIX . $field['slug']; ?>_date_<?php echo $counter; ?>" value="<?php echo $value['date']; ?>" />&nbsp;&nbsp;&nbsp;&nbsp;
							
							Start Time: <input type="text" size="5" name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>_starttime]<?php if ($field['multiple'] == true) : ?>[]<?php endif; ?>" id="<?php echo OAK_PREFIX . $field['slug']; ?>_starttime" value="<?php echo $value['starttime']; ?>" />
							
							End Time: <input type="text" size="5" name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>_endtime]<?php if ($field['multiple'] == true) : ?>[]<?php endif; ?>" id="<?php echo OAK_PREFIX . $field['slug']; ?>_endtime" value="<?php echo $value['endtime']; ?>" />
							
							<?php if ($counter != 0) : ?>
								<input type='image' src='<?php bloginfo('template_url'); ?>/framework/images/close_icon.png' class='removesection' style='vertical-align: bottom' />
							<?php endif; ?>
							
						</fieldset>
										
					<?php $counter++;
						endforeach;
					break;
					
					// Date Picker Field
					case "calendar": 
						$caldate = get_post_meta($post->ID, OAK_PREFIX . $field['slug'], true); ?>
					
					<fieldset class="calendar">
					
					    <label for="<?php echo OAK_PREFIX . $field['slug']; ?>">
					    	<strong><?php echo $field['name']; ?></strong>
					    </label>
						<input type="text" class="calendar" name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>]" id="<?php echo OAK_PREFIX . $field['slug']; ?>" value="<?php echo ($caldate) ? date('F j, Y', htmlspecialchars($caldate)) : null; ?>" />					
					</fieldset>
					
					<?php break;
					
					// Checkbox Field 
					case "checkbox": ?>
					
						<fieldset class="checkbox">
						
							<label for="<?php echo OAK_PREFIX . $field['slug']; ?>" style="display:inline;">
								<strong><?php echo $field['name']; ?></strong>
							</label>&nbsp;&nbsp;
							<input type="checkbox" name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>]" id="<?php echo OAK_PREFIX . $field['slug']; ?>" value="yes" <?php if (get_post_meta($post->ID, OAK_PREFIX . $field['slug'], true ) == "yes") : ?>checked="checked"<?php endif; ?> style="width: auto;" />
						
						</fieldset>
					
					<?php break;
					
					// Dropdown Select Field 
					case "dropdown": 
									
						$dropdown_items = $field['items'];
						$selected = htmlspecialchars(get_post_meta($post->ID, OAK_PREFIX . $field['slug'], true)); ?>
						
						<fieldset class="dropdown">
						
						    <label for="<?php echo OAK_PREFIX . $field['slug']; ?>">
						    	<strong><?php echo $field['name']; ?></strong>
						    </label>
							<select name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>]" id="<?php echo OAK_PREFIX . $field['slug']; ?>" value="<?php echo $selected; ?> ">
							<?php foreach ($dropdown_items as $dropdown_item) :
							  if ($dropdown_item == $selected) : ?>
							    <option value="<?php echo $dropdown_item; ?>" selected="selected"><?php echo $dropdown_item; ?></option>
							  <?php else : ?>
							  	<option value="<?php echo $dropdown_item; ?>"><?php echo $dropdown_item; ?></option>
							  <?php endif; 
							endforeach; ?>
							</select>
							
						</fieldset>
					
					<?php break;
									
					// Wordpress Media Library Upload Field
					case "upload":
					 
						$fieldvalues = array();
						$i = 0;
					
						if (get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . '_' . $i, true) != null) {
							while ($fieldvalue = get_post_meta($post->ID, OAK_PREFIX . $field['slug'] . '_' . $i, true)) {
								$fieldvalues[$i] = $fieldvalue;
								$i++;
							}
						} 
						
						?>
										
						<fieldset class="upload">
						
						    <label for="<?php echo OAK_PREFIX . $field['slug']; ?>">
						    	<strong><?php echo $field['name']; ?></strong>
						    </label>
							<div style="margin:10px" id="<?php echo OAK_PREFIX . $field['slug']; ?>_attach">
							<?php foreach ($fieldvalues as $value) : 
							if ($value != null) : ?>
							<p><?php echo wp_get_attachment_link($value); ?> <img id="<?php echo $value; ?>" src='<?php bloginfo('template_url'); ?>/framework/images/close_icon.png' class='removeattach' style='vertical-align:bottom;margin:0px 0px 0px 5px;padding:0' />
							</p>
							<?php endif; 
							endforeach; ?>
							</div>
							<div style="margin:10px 0px" id="<?php echo OAK_PREFIX . $field['slug']; ?>_input">
							<?php $counter = 0;
							foreach ($fieldvalues as $value) : ?>
								<input type="hidden" name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>][]" id="<?php echo OAK_PREFIX . $field['slug']; ?>_<?php echo $counter++; ?>" value="<?php echo $value; ?>" />
							<?php endforeach; ?>
								<input type="hidden" name="" id="<?php echo OAK_PREFIX . $field['slug']; ?>" value="" />
								<a onclick="return false;" title="Upload image" class="button-primary mediaupload thickbox" id="<?php echo OAK_PREFIX . $field['slug']; ?>" href="media-upload.php?type=file&amp;TB_iframe=true&amp;width=640&amp;height=105">Attach File</a>
							</div>
							
						</fieldset>
					<?php break;
					
					// Textarea or WYSIWYG Editor Field
					case "textarea": ?>
					
						<fieldset class="textarea">
						
							<label for="<?php echo OAK_PREFIX . $field['slug']; ?>">
								<strong><?php echo $field['name']; ?></strong>
							</label>
							<div class="wysiwyg">
								<textarea class="noborder" style="width:100%;height:200px" name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>]" id="<?php echo OAK_PREFIX . $field['slug']; ?>"><?php echo get_post_meta( $post->ID, OAK_PREFIX . $field['slug'], true ); ?></textarea>
							</div>
							
						</fieldset>
					
					<?php break;
					
					case "wysiwyg": ?>

						<fieldset class="wysiwyg">
						
							<label for="<?php echo OAK_PREFIX . $field['slug']; ?>">
								<strong><?php echo $field['name']; ?></strong>
							</label>
							<div class="wysiwyg">
								<textarea class="noborder" name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>]" id="<?php echo OAK_PREFIX . $field['slug']; ?>" columns="30" rows="3"><?php echo htmlspecialchars( get_post_meta( $post->ID, OAK_PREFIX . $field['slug'], true ) ); ?></textarea>
							</div>
								
							<a style="display: block; text-align: right; margin: 10px 20px 0 0" href="javascript:toggleEditor('<?php echo OAK_PREFIX . $field['slug']; ?>');">Add/Remove editor</a>
							<script type="text/javascript">
								function toggleEditor(id) {
					              if (!tinyMCE.get(id))
					                tinyMCE.execCommand('mceAddControl', false, id);
					              else
					                tinyMCE.execCommand('mceRemoveControl', false, id);
					            }
								jQuery(document).ready(function() {
									jQuery( "<?php echo OAK_PREFIX . $field['slug']; ?>" ).addClass( "mceEditor" );
									if ( typeof( tinyMCE ) == "object" && typeof( tinyMCE.execCommand ) == "function" ) {
										tinyMCE.execCommand( "mceAddControl", false, "<?php echo OAK_PREFIX . $field['slug']; ?>" );
									}
								});
							</script> 
							
						</fieldset>
						
					<?php break;
					
					// Regular Text Input Field
					default:
					
						$value = htmlspecialchars(get_post_meta($post->ID, OAK_PREFIX . $field['slug'], true));
						if ($value == "" && isset($field['default']))
							$value = $field['default']; ?>
					
						<fieldset class="text">
					
							<label for="<?php echo OAK_PREFIX . $field['slug']; ?>">
								<strong><?php echo $field['name']; ?></strong>
							</label>
							<input type="text" name="_cf[<?php echo OAK_PREFIX . $field['slug']; ?>]" id="<?php echo OAK_PREFIX . $field['slug']; ?>" value="<?php echo $value; ?>" />
						
						</fieldset>
							
				<?php break; 
				endswitch; ?>
			</div>			
			<?php if ($field['multiple'] == true) : ?>
				<p><input type="button" class="button-primary addnewsection" id="addnewsection" value="Add New" /></p>
			<?php endif; 
			endforeach; ?>
			
			<div class="clear"></div>
				
		</div> 
		
		<?php 
		}
		
		function save_custom_fields() {
			global $post;
			
			if (isset($_POST['my-custom-fields_wpnonce']) && !wp_verify_nonce($_POST['my-custom-fields_wpnonce'], 'my-custom-fields'))
				return false;
				
			if(!current_user_can('edit_post', $post->ID))
				return false;
			  
			/* Add logic that checks if proper supported post type */
			
			$newdata = $_POST['_cf'];

			if (!empty($newdata)) :
				
				// Clear Existing Meta //
				foreach ($this->cmf->fields as $field) { 
					if ($field['type'] == 'datetime') {
						$i = 0;
						while (get_custom_field(OAK_PREFIX . $field['slug'] . '_date_' . $i) != null) {
							delete_post_meta($post->ID, OAK_PREFIX . $field['slug'] . '_date_' . $i);
							delete_post_meta($post->ID, OAK_PREFIX . $field['slug'] . '_starttime_' . $i);
							delete_post_meta($post->ID, OAK_PREFIX . $field['slug'] . '_endtime_' . $i);
							$i++;
						}							
					} else if ($field['type'] == 'upload') {
						$i = 0;
						while (get_custom_field(OAK_PREFIX . $field['slug'] . '_' . $i) != null) {
							delete_post_meta($post->ID, OAK_PREFIX . $field['slug'] . '_' . $i);
							$i++;
						}	
					}

					delete_post_meta($post->ID, OAK_PREFIX . $field['slug']);
				}
				
				foreach ($newdata as $field => $value) :
					
					// For Multiple of a Field //
					if (is_array($value)) {
						$i = 0;
						foreach ($value as $afield => $avalue) {
							// Temporary Field Handling //
							if ($field == '_event_date_date') {
								date_default_timezone_set('America/Toronto');						
								$avalue = strtotime($avalue);
							}
								
							if ($avalue != null)
								add_post_meta($post->ID, $field."_".$afield, $avalue);
						}
					// Single Fields //
					} else {				

				 		if ($value != null)
							add_post_meta($post->ID, $field, $value);
					}
				endforeach;
				
			endif;
	   	}
	} 
}
?>