<?php

if (!class_exists('OAK_Upload_Fields')) {
		
	class OAK_Upload_Fields {
		
		function __construct() {
			add_action( 'admin_init', array( $this, 'fix_async_upload_image' ) );
		
		 	add_filter( 'image_send_to_editor', array( $this,'send_to_editor'), 1, 8 );
			add_filter( 'file_send_to_editor', array( $this,'send_to_editor'), 1, 8 );
			add_filter( 'media_send_to_editor', array( $this,'send_to_editor'), 1, 8 );
			add_filter( 'video_send_to_editor', array( $this,'send_to_editor'), 1, 8 );
			
			add_filter( 'gettext', array( $this, 'replace_text_in_thickbox' ), 1, 3 );
			add_filter( 'media_upload_tabs', array( $this, 'media_upload_tabs' ) );
		}
	
		function is_meta_attachment() {
			if (isset($_REQUEST['action']) && $_REQUEST['action'] == 'send-attachment-to-editor') {
				return false;
			} else {
				return true;
			}
		}
		
		function fix_async_upload_image() {
			if (isset($_REQUEST['attachment_id'])) {
				$GLOBALS['post'] = get_post($_REQUEST['attachment_id']);
			} 
		}
		
		function replace_text_in_thickbox($translated_text, $source_text, $domain) {
			if ( $this->is_meta_attachment() ) {
				if ('Insert into Post' == $source_text) {
					return 'Attach to Article';
				}
			}
			return $translated_text;
		}
		
		function send_to_editor( $html, $id) {
			if ( $this->is_meta_attachment() ) {
				return json_encode(array('id' => $id, 'data' => stripslashes($html)));
			}
			return $html;
		}
				
		function media_upload_tabs($tabs) {
			if ( $this->is_meta_attachment() ) {
				unset($tabs['type_url']);
			}
			return $tabs;
		}
	}
	
	new OAK_Upload_Fields();
}
?>