<?php
if (get_locale() == 'fr_FR') {
	add_action('wp_enqueue_scripts', 'add_french_dates');

	function add_french_dates() {		
		wp_enqueue_script('french_dates', '/wp-content/themes/francais/includes/date-fr.js');
		wp_enqueue_script('french_placeholders', '/wp-content/plugins/oak-events/includes/date-fr.js');
	}
} else {
	add_action('wp_enqueue_scripts', 'add_english_dates');

	function add_english_dates() {		
		wp_enqueue_script('english_dates', '/wp-content/plugins/oak-events/includes/date-en.js');
	}
}

function page_includes() {
    wp_enqueue_script( 'prototype', '/wp-content/plugins/oak-events/includes/prototype.js', array('jquery'));
    wp_enqueue_script( 'timeframe', '/wp-content/plugins/oak-events/includes/timeframe.js', array('jquery'));
    wp_enqueue_script( 'datepicker', '/wp-content/plugins/oak-events/includes/datepicker.min.js', array('jquery'));
    wp_enqueue_script( 'eventcalendar', '/wp-content/plugins/oak-events/includes/eventcalendar.js', array('jquery'));
	wp_enqueue_style( 'timeframe', '/wp-content/plugins/oak-events/includes/timeframe.css', array('jquery'));
	wp_enqueue_style( 'calendar-style', '/wp-content/plugins/oak-events/includes/style.css');
}    

add_action('wp_enqueue_scripts', 'page_includes');

get_header(); 
get_sidebar() ;

	national_blog_events();

	//EventHelper::get_plugin_template('sidebar', 'events'); ?>
	
	<div class="content wide events event">

		<div>
			<?php the_breadcrumbs(); ?>
			<div class="search right">	
				<form id="keywords">
					<input type="text" class="search-input" name="keyword" placeholder="<?php _e('Search Events', 'p2p'); ?>" />
					<input type="submit" class="submiticon" value="" />
				</form>
			</div>
		</div>

		<h2>
			<?php _e('Events', 'p2p'); ?>
		</h2>

		<?php // The Blurb // 
		the_blurb(); ?>


		<hr/>

		<div id="loadingicon" style="float:right;display:none">
			<h3>
				<img style="box-shadow:none" src="<?php bloginfo('template_url'); ?>/images/loading_icon.gif" /> &nbsp; <?php _e('Loading', 'p2p'); ?>...
			</h3>
			<hr/>
		</div>

		<div class="eventlisting">
			<?php EventHelper::get_plugin_template('content', 'events'); ?>
		</div>

	</div>	

<?php get_footer(); ?>