<?php 
function page_includes() {
    wp_enqueue_script( 'prototype', '/wp-content/plugins/oak-events/includes/prototype.js', array('jquery'));
    wp_enqueue_script( 'timeframe', '/wp-content/plugins/oak-events/includes/timeframe.js', array('jquery'));
    wp_enqueue_script( 'datepicker', '/wp-content/plugins/oak-events/includes/datepicker.min.js', array('jquery'));
    wp_enqueue_script( 'eventcalendar', '/wp-content/plugins/oak-events/includes/eventcalendar.js', array('jquery'));
	wp_enqueue_style( 'timeframe', '/wp-content/plugins/oak-events/includes/timeframe.css', array('jquery'));
	wp_enqueue_style( 'calendar-style', '/wp-content/plugins/oak-events/includes/style.css');
}    

add_action('wp_enqueue_scripts', 'page_includes');

get_header(); 

	get_sidebar(); ?>
	
	<div class="content wide event">
		
		<div>
			<?php the_breadcrumbs(); ?>
			<div class="search right">
				<?php get_template_part('search'); ?>
			</div>
		</div>

		<?php 
		national_blog_events();
		if (have_posts()) : 
		while (have_posts()) : the_post(); 
			$dates = EventHelper::get_event_date_meta(get_the_ID()); 
			?>

			<article id="post-<?php the_ID(); ?>">

				<h2><?php the_title(); ?></h2>
				<hr />
				<time><?php EventHelper::date_display($dates); ?></time>
				<div>
					<?php if (($location = get_custom_field('_event_location')) != null) : ?>
						<strong><?php echo $location; ?></strong><br/>
					<?php endif; ?>
					<?php if (($street = get_custom_field('_event_street_address')) != null) : ?>
						<a href="http://maps.google.com/?q=<?php echo $street; ?>" target="_blank"><img src="/wp-content/plugins/oak-events/images/pin.png" class="googlepin" /></a>
						<?php echo $street; ?><br/>
						<a href="http://maps.google.com/?q=<?php echo $street; ?>" target="_blank">See Map</a>				
					<?php endif; ?>
				</div>
				<div class="right">
					<a href="/ical/<?php echo $post->post_name; ?>"><img src="/wp-content/plugins/oak-events/images/ical.png" class="ical" /> iCal / Google Calendar (.ics)</a>
					<?php if (($eventbrite = get_custom_field('_event_eventbrite')) != null) : ?>
					<p>
						<a href="<?php echo $eventbrite; ?>" class="right button" target="_blank">Register</a>
					</p>
					<?php endif; ?>
				</div>

				<section>
					<?php if (($price = get_custom_field('_event_price')) != null || ($website = get_custom_field('_event_website')) != null) : ?>
					<div>
						<?php if (($price = get_custom_field('_event_price')) != null) : ?>
							<strong>Price</strong>: <?php echo $price; ?><br/>
						<?php endif; 
						if (($website = get_custom_field('_event_website')) != null) : ?>
							<strong>Website</strong>: <a href="<?php echo $website; ?>"><?php echo $website; ?></a>
						<?php endif; ?>
					</div>
					<?php endif; ?>
					
					<?php the_content(); ?>
				</section>

				<?php if (($hashtag = get_custom_field('_twitter_feed')) != null) : 
				$twitter = EventHelper::get_tweet($hashtag); 
				if ($twitter != false) : ?>
				<img src="/wp-content/plugins/oak-events/images/twitterbird.png" class="twitterbird" />
				<div id="twitter">
					<img src="<?php echo $twitter['image']; ?>" />
					<div>
						<strong><?php echo $twitter['author']; ?></strong><br/>
						<?php echo $twitter['tweet']; ?><br/>
						<span><?php echo date('d M', $twitter['date']); ?></span>
					</div>
				</div>
				<?php endif;
				endif; ?>
		
			</article>		
				 				
		<?php
		endwhile; 
	endif; ?>

	</div>

<?php get_footer(); ?>