<?php 

class Todays_Events extends WP_Widget {

	function __construct() {
		parent::WP_Widget('todays_events', 'Today\'s Events', array('description' => 'Displays a featured event, and other events occuring today' ) );
	}

	function widget( $args, $instance ) {
		global $post;
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		
		$pageposts = EventHelper::get_event_by_date(); 
		$i = 0; 
		if ($pageposts):
			echo $before_widget;
			if ( $title )
				echo $before_title . $title . $after_title; 
		 	foreach ($pageposts as $post):
				setup_postdata($post); 
				if ($i == 0) : 
					$dates = EventHelper::get_event_date_meta($post->ID); 
					?>
					<div class="dateblock <?php echo (!has_post_thumbnail()) ? 'nomargin' : null; ?>">			
						<?php EventHelper::the_date_icon($dates); ?>
					</div>			
						
					<?php EventHelper::the_article_image('widget'); ?>
									
					<h2><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h2>
					<p><?php show_excerpt('event'); ?></p>
				<?php endif;
				if ($i == 1) echo '<hr/><ul>';
				if ($i >= 1) : ?>
					<li><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></li>
				<?php endif;
				$i++;
			endforeach;
			if ($i >= 1) echo "</ul>";
			echo $after_widget;
		endif; 
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		return $instance;
	}

	function form( $instance ) {
		if ( $instance ) 
			$title = esc_attr( $instance[ 'title' ] );
		else 
			$title = __( 'Today\'s Events', 'oak');
		?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
		</p>
		<?php 
	}

}
