<?php 

class Upcoming_Events extends WP_Widget {

	function __construct() {
		parent::WP_Widget('upcoming_events', 'Upcoming Events', array('description' => 'Displays a featured event, and other events occuring chronologically after today' ) );
	}

	function widget( $args, $instance ) {
		global $post;
		
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		
		$pageposts = EventHelper::get_event_by_date(true); 

		if ($pageposts) { 
			echo $before_widget;
			if ($title)
				$output = $before_title . '<a href="/events/">' . $title . '</a>' . $after_title; 
			else {
				$output = $before_title . '<a href="/events/">Events</a>' . $after_title;
			} 
			$output .= '<ul class="eventlist">';
		 	foreach ($pageposts as $post) {
				setup_postdata($post); 
				$dates = EventHelper::get_event_date_meta($post->ID); 
				$output .= '<li>';
					$output .= '<div class="dateblock">';
						$output .= EventHelper::the_date_icon($dates);
					$output .= '</div>';			
					$output .= '<h4><a href="'.get_permalink().'">'.get_the_title().'</a></h4>';
				$output .= '</li>';
			}
			$output .= '<li>
							<a href="/suggest-event/" class="greenbutton"><strong>Suggest an Event</strong> (Members Only)</a>
						</li>';
			$output .= '</ul>';
			$output .= $after_widget;
			
			echo $output;
		} 
	}

	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		return $instance;
	}

	function form( $instance ) {
		if ( $instance ) 
			$title = esc_attr( $instance[ 'title' ] );
		else 
			$title = __( 'Upcoming Events', 'oak');
		?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
		</p>
		<?php 
	}

}
